Index: /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/NST_SRC/agrif_top_update.F90
===================================================================
--- /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/NST_SRC/agrif_top_update.F90	(revision 8740)
+++ /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/NST_SRC/agrif_top_update.F90	(revision 8741)
@@ -33,12 +33,11 @@
 CONTAINS
 
-   SUBROUTINE Agrif_Update_Trc( kt )
+   SUBROUTINE Agrif_Update_Trc( )
       !!----------------------------------------------------------------------
       !!                   *** ROUTINE Agrif_Update_Trc ***
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt
-      !!----------------------------------------------------------------------
       ! 
-      IF((Agrif_NbStepint() .NE. (Agrif_irhot()-1)).AND.(kt /= 0)) RETURN
+      IF (Agrif_Root()) RETURN 
+      !
 #if defined TWO_WAY   
       Agrif_UseSpecialValueInUpdate = .TRUE.
@@ -66,5 +65,5 @@
 
 
-   SUBROUTINE updateTRC( ptab, i1, i2, j1, j2, k1, k2, n1, n2, before )
+   SUBROUTINE updateTRC( ptab, i1, i2, j1, j2, k1, k2, n1, n2, before, nb, ndir )
       !!----------------------------------------------------------------------
       !!                      *** ROUTINE updateT ***
@@ -73,33 +72,56 @@
       REAL(wp),DIMENSION(i1:i2,j1:j2,k1:k2,n1:n2), INTENT(inout) ::   ptab
       LOGICAL                                    , INTENT(in   ) ::   before
+      INTEGER, INTENT(in) :: nb, ndir
       !!
-      INTEGER ::   ji, jj, jk, jn
-      !!----------------------------------------------------------------------
-      !
-      IF( before ) THEN
-         ptab(i1:i2,j1:j2,k1:k2,n1:n2) = trn(i1:i2,j1:j2,k1:k2,n1:n2)
-      ELSE
-         IF( .NOT.(lk_agrif_fstep.AND.(neuler==0)) ) THEN
-            ! Add asselin part
-            DO jn = n1,n2
-               DO jk = k1, k2
-                  DO jj = j1, j2
-                     DO ji = i1, i2
-                        IF( ptab(ji,jj,jk,jn) /= 0._wp ) THEN
-                           trb(ji,jj,jk,jn) = trb(ji,jj,jk,jn)             & 
-                              &             + atfp * ( ptab(ji,jj,jk,jn)   &
-                                 &                    - trn(ji,jj,jk,jn) ) * tmask(ji,jj,jk)
-                        ENDIF
-                     END DO
+      LOGICAL :: western_side, eastern_side, southern_side, northern_side 
+      INTEGER :: ji,jj,jk,jn
+      REAL(wp) :: ztb, ztnu, ztno
+      !!----------------------------------------------------------------------
+      !
+      !
+      IF (before) THEN
+         DO jn = n1,n2
+            DO jk=k1,k2
+               DO jj=j1,j2
+                  DO ji=i1,i2
+!> jc tmp
+                     tabres(ji,jj,jk,jn) = trn(ji,jj,jk,jn)  * e3t_n(ji,jj,jk) / e3t_0(ji,jj,jk)
+!                     tabres(ji,jj,jk,jn) = trn(ji,jj,jk,jn)  * e3t_n(ji,jj,jk)
+!< jc tmp
                   END DO
                END DO
             END DO
+         END DO
+      ELSE
+!> jc tmp
+         DO jn = n1,n2
+            tabres(i1:i2,j1:j2,k1:k2,jn) =  tabres(i1:i2,j1:j2,k1:k2,jn) * e3t_0(i1:i2,j1:j2,k1:k2) &
+                                         & * tmask(i1:i2,j1:j2,k1:k2)
+         ENDDO
+!< jc tmp
+         IF (.NOT.(lk_agrif_fstep.AND.(neuler==0))) THEN
+            ! Add asselin part
+            DO jn = n1,n2
+               DO jk=k1,k2
+                  DO jj=j1,j2
+                     DO ji=i1,i2
+                        IF( tabres(ji,jj,jk,jn) .NE. 0. ) THEN
+                           ztb  = trb(ji,jj,jk,jn) * e3t_b(ji,jj,jk) ! fse3t_b prior update should be used
+                           ztnu = tabres(ji,jj,jk,jn)
+                           ztno = trn(ji,jj,jk,jn) * e3t_a(ji,jj,jk)
+                           trb(ji,jj,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
+                                     &        * tmask(ji,jj,jk) / e3t_b(ji,jj,jk)
+                        ENDIF
+                     ENDDO
+                  ENDDO
+               ENDDO
+            ENDDO
          ENDIF
-         DO jn = n1, n2
-            DO jk = k1, k2
-               DO jj = j1, j2
-                  DO ji = i1, i2
-                     IF( ptab(ji,jj,jk,jn) /= 0._wp ) THEN 
-                        trn(ji,jj,jk,jn) = ptab(ji,jj,jk,jn) * tmask(ji,jj,jk)
+         DO jn = n1,n2
+            DO jk=k1,k2
+               DO jj=j1,j2
+                  DO ji=i1,i2
+                     IF( tabres(ji,jj,jk,jn) .NE. 0. ) THEN 
+                        trn(ji,jj,jk,jn) = tabres(ji,jj,jk,jn) / e3t_n(ji,jj,jk)
                      END IF
                   END DO
@@ -107,4 +129,111 @@
             END DO
          END DO
+         !
+         IF  ((neuler==0).AND.(Agrif_Nb_Step()==0) ) THEN
+            trb(i1:i2,j1:j2,k1:k2,n1:n2)  = trn(i1:i2,j1:j2,k1:k2,n1:n2)
+         ENDIF
+         !
+         !
+# if defined DECAL_FEEDBACK
+         IF (.NOT.ln_linssh) THEN 
+            western_side  = (nb == 1).AND.(ndir == 1)
+            eastern_side  = (nb == 1).AND.(ndir == 2)
+            southern_side = (nb == 2).AND.(ndir == 1)
+            northern_side = (nb == 2).AND.(ndir == 2)
+            !
+            ! Asselin correction 
+            IF (.NOT.(lk_agrif_fstep.AND.(neuler==0))) THEN
+               IF (southern_side) THEN
+                  DO jn = n1,n2
+                     DO jk=k1,k2
+                        DO ji=i1,i2
+                           ztb  = trb(ji,j1-1,jk,jn) * e3t_b(ji,j1-1,jk) ! fse3t_b prior update should be used
+                           ztnu = trn(ji,j1-1,jk,jn) * e3t_n(ji,j1-1,jk)
+                           ztno = trn(ji,j1-1,jk,jn) * e3t_a(ji,j1-1,jk)
+                           trb(ji,j1-1,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
+                                     &        * tmask(ji,j1-1,jk) / e3t_b(ji,j1-1,jk)
+                        END DO
+                     ENDDO
+                  ENDDO
+               ENDIF
+               IF (northern_side) THEN
+                  DO jn = n1,n2
+                     DO jk=k1,k2
+                        DO ji=i1,i2
+                           ztb  = trb(ji,j2+1,jk,jn) * e3t_b(ji,j2+1,jk) ! fse3t_b prior update should be used
+                           ztnu = trn(ji,j2+1,jk,jn) * e3t_n(ji,j2+1,jk)
+                           ztno = trn(ji,j2+1,jk,jn) * e3t_a(ji,j2+1,jk)
+                           trb(ji,j2+1,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
+                                     &        * tmask(ji,j2+1,jk) / e3t_b(ji,j2+1,jk)
+                        END DO
+                     ENDDO
+                  ENDDO
+               ENDIF
+               IF (western_side) THEN
+                  DO jn = n1,n2
+                     DO jk=k1,k2
+                        DO jj=j1,j2
+                           ztb  = trb(i1-1,jj,jk,jn) * e3t_b(i1-1,jj,jk) ! fse3t_b prior update should be used
+                           ztnu = trn(i1-1,jj,jk,jn) * e3t_n(i1-1,jj,jk)
+                           ztno = trn(i1-1,jj,jk,jn) * e3t_a(i1-1,jj,jk)
+                           trb(i1-1,jj,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
+                                     &        * tmask(i1-1,jj,jk) / e3t_b(i1-1,jj,jk)
+                        END DO
+                     ENDDO
+                  ENDDO
+               ENDIF
+               IF (eastern_side) THEN
+                  DO jn = n1,n2
+                     DO jk=k1,k2
+                        DO jj=j1,j2
+                           ztb  = trb(i2+1,jj,jk,jn) * e3t_b(i2+1,jj,jk) ! fse3t_b prior update should be used
+                           ztnu = trn(i2+1,jj,jk,jn) * e3t_n(i2+1,jj,jk)
+                           ztno = trn(i2+1,jj,jk,jn) * e3t_a(i2+1,jj,jk)
+                           trb(i2+1,jj,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
+                                     &        * tmask(i2+1,jj,jk) / e3t_b(i2+1,jj,jk)
+                        END DO
+                     ENDDO
+                  ENDDO
+               ENDIF
+            ENDIF ! Asselin correction
+
+            IF (southern_side) THEN
+               DO jn = n1,n2
+                  DO jk=k1,k2
+                     DO ji=i1,i2
+                        trn(ji,j1-1,jk,jn) = trn(ji,j1-1,jk,jn) * e3t_a(ji,j1-1,jk) / e3t_n(ji,j1-1,jk)
+                     END DO
+                  ENDDO
+               ENDDO
+            ENDIF
+            IF (northern_side) THEN
+               DO jn = n1,n2
+                  DO jk=k1,k2
+                     DO ji=i1,i2
+                        trn(ji,j2+1,jk,jn) = trn(ji,j2+1,jk,jn) * e3t_a(ji,j2+1,jk) / e3t_n(ji,j2+1,jk)
+                     END DO
+                  ENDDO
+               ENDDO
+            ENDIF
+            IF (western_side) THEN
+               DO jn = n1,n2
+                  DO jk=k1,k2
+                     DO jj=j1,j2
+                        trn(i1-1,jj,jk,jn) = trn(i1-1,jj,jk,jn) * e3t_a(i1-1,jj,jk) / e3t_n(i1-1,jj,jk)
+                     END DO
+                  ENDDO
+               ENDDO
+            ENDIF
+            IF (eastern_side) THEN
+               DO jn = n1,n2
+                  DO jk=k1,k2
+                     DO jj=j1,j2
+                        trn(i2+1,jj,jk,jn) = trn(i2+1,jj,jk,jn) * e3t_a(i2+1,jj,jk) / e3t_n(i2+1,jj,jk)
+                     END DO
+                  ENDDO
+               ENDDO
+            ENDIF
+         ENDIF
+#endif
       ENDIF
       ! 
Index: /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/NST_SRC/agrif_user.F90
===================================================================
--- /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/NST_SRC/agrif_user.F90	(revision 8740)
+++ /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/NST_SRC/agrif_user.F90	(revision 8741)
@@ -1,2 +1,3 @@
+#undef UPD_HIGH   /* MIX HIGH UPDATE */
 #if defined key_agrif
 !!----------------------------------------------------------------------
@@ -88,4 +89,13 @@
 # endif
    !
+   nbcline     = 0
+#if defined key_top
+   nbcline_trc = 0
+#endif
+   !
+   IF ( Agrif_Level().EQ.Agrif_MaxLevel() ) CALL agrif_Update_ini()
+
+   Agrif_UseSpecialValueInUpdate = .FALSE.     
+
 END SUBROUTINE Agrif_initvalues
 
@@ -144,13 +154,14 @@
    CALL Agrif_Set_bc(e2v_id,(/0,0/))
 
-   ! 5. Update type
+   ! 4. Update type
    !--------------- 
+# if defined UPD_HIGH
+   CALL Agrif_Set_Updatetype(e1u_id,update1 = Agrif_Update_Average, update2=Agrif_Update_Full_Weighting)
+   CALL Agrif_Set_Updatetype(e2v_id,update1 = Agrif_Update_Full_Weighting, update2=Agrif_Update_Average)
+#else
    CALL Agrif_Set_Updatetype(e1u_id,update1 = Agrif_Update_Copy, update2=Agrif_Update_Average)
    CALL Agrif_Set_Updatetype(e2v_id,update1 = Agrif_Update_Average, update2=Agrif_Update_Copy)
-
-! High order updates
-!   CALL Agrif_Set_Updatetype(e1u_id,update1 = Agrif_Update_Average,            update2=Agrif_Update_Full_Weighting)
-!   CALL Agrif_Set_Updatetype(e2v_id,update1 = Agrif_Update_Full_Weighting,     update2=Agrif_Update_Average)
-    !
+#endif
+
 END SUBROUTINE agrif_declare_var_dom
 
@@ -175,5 +186,5 @@
    !
    LOGICAL :: check_namelist
-   CHARACTER(len=15) :: cl_check1, cl_check2, cl_check3
+   CHARACTER(len=15) :: cl_check1, cl_check2, cl_check3, cl_check4 
    !!----------------------------------------------------------------------
 
@@ -205,4 +216,6 @@
    Agrif_UseSpecialValue = .TRUE.
    CALL Agrif_Bc_variable(sshn_id,calledweight=1., procname=interpsshn )
+   hbdy_w(:) = 0.e0 ; hbdy_e(:) = 0.e0 ; hbdy_n(:) = 0.e0 ; hbdy_s(:) = 0.e0
+   ssha(:,:) = 0.e0
 
    IF ( ln_dynspg_ts ) THEN
@@ -212,8 +225,8 @@
       CALL Agrif_Bc_variable(ub2b_interp_id,calledweight=1.,procname=interpub2b)
       CALL Agrif_Bc_variable(vb2b_interp_id,calledweight=1.,procname=interpvb2b)
-      ubdy_w(:) = 0.e0 ; vbdy_w(:) = 0.e0 ; hbdy_w(:) =0.e0
-      ubdy_e(:) = 0.e0 ; vbdy_e(:) = 0.e0 ; hbdy_e(:) =0.e0 
-      ubdy_n(:) = 0.e0 ; vbdy_n(:) = 0.e0 ; hbdy_n(:) =0.e0 
-      ubdy_s(:) = 0.e0 ; vbdy_s(:) = 0.e0 ; hbdy_s(:) =0.e0
+      ubdy_w(:) = 0.e0 ; vbdy_w(:) = 0.e0
+      ubdy_e(:) = 0.e0 ; vbdy_e(:) = 0.e0
+      ubdy_n(:) = 0.e0 ; vbdy_n(:) = 0.e0
+      ubdy_s(:) = 0.e0 ; vbdy_s(:) = 0.e0
    ENDIF
 
@@ -234,5 +247,5 @@
          WRITE(cl_check2,*)  NINT(rdt)
          WRITE(cl_check3,*)  NINT(Agrif_Parent(rdt)/Agrif_Rhot())
-         CALL ctl_stop( 'incompatible time step between ocean grids',   &
+         CALL ctl_stop( 'Incompatible time step between ocean grids',   &
                &               'parent grid value : '//cl_check1    ,   & 
                &               'child  grid value : '//cl_check2    ,   & 
@@ -245,39 +258,36 @@
          WRITE(cl_check1,*)  (Agrif_Parent(nit000)-1)*Agrif_IRhot() + 1
          WRITE(cl_check2,*)   Agrif_Parent(nitend)   *Agrif_IRhot()
-         CALL ctl_warn( 'incompatible run length between grids'               ,   &
-               &              ' nit000 on fine grid will be change to : '//cl_check1,   &
-               &              ' nitend on fine grid will be change to : '//cl_check2    )
+         CALL ctl_warn( 'Incompatible run length between grids'                      ,   &
+               &               'nit000 on fine grid will be changed to : '//cl_check1,   &
+               &               'nitend on fine grid will be changed to : '//cl_check2    )
          nit000 = (Agrif_Parent(nit000)-1)*Agrif_IRhot() + 1
          nitend =  Agrif_Parent(nitend)   *Agrif_IRhot()
       ENDIF
 
-      ! Check coordinates
-     !SF  IF( ln_zps ) THEN
-     !SF     ! check parameters for partial steps 
-     !SF     IF( Agrif_Parent(e3zps_min) .NE. e3zps_min ) THEN
-     !SF        WRITE(*,*) 'incompatible e3zps_min between grids'
-     !SF        WRITE(*,*) 'parent grid :',Agrif_Parent(e3zps_min)
-     !SF        WRITE(*,*) 'child grid  :',e3zps_min
-     !SF        WRITE(*,*) 'those values should be identical'
-     !SF        STOP
-     !SF     ENDIF
-     !SF     IF( Agrif_Parent(e3zps_rat) /= e3zps_rat ) THEN
-     !SF        WRITE(*,*) 'incompatible e3zps_rat between grids'
-     !SF        WRITE(*,*) 'parent grid :',Agrif_Parent(e3zps_rat)
-     !SF        WRITE(*,*) 'child grid  :',e3zps_rat
-     !SF        WRITE(*,*) 'those values should be identical'                  
-     !SF        STOP
-     !SF     ENDIF
-     !SF  ENDIF
-
       ! Check free surface scheme
       IF ( ( Agrif_Parent(ln_dynspg_ts ).AND.ln_dynspg_exp ).OR.&
          & ( Agrif_Parent(ln_dynspg_exp).AND.ln_dynspg_ts ) ) THEN
-         WRITE(*,*) 'incompatible free surface scheme between grids'
-         WRITE(*,*) 'parent grid ln_dynspg_ts  :', Agrif_Parent(ln_dynspg_ts )
-         WRITE(*,*) 'parent grid ln_dynspg_exp :', Agrif_Parent(ln_dynspg_exp)
-         WRITE(*,*) 'child grid  ln_dynspg_ts  :', ln_dynspg_ts
-         WRITE(*,*) 'child grid  ln_dynspg_exp :', ln_dynspg_exp
-         WRITE(*,*) 'those logicals should be identical'                  
+         WRITE(cl_check1,*)  Agrif_Parent( ln_dynspg_ts )
+         WRITE(cl_check2,*)  ln_dynspg_ts
+         WRITE(cl_check3,*)  Agrif_Parent( ln_dynspg_exp )
+         WRITE(cl_check4,*)  ln_dynspg_exp
+         CALL ctl_stop( 'Incompatible free surface scheme between grids' ,  &
+               &               'parent grid ln_dynspg_ts  :'//cl_check1  ,  & 
+               &               'child  grid ln_dynspg_ts  :'//cl_check2  ,  &
+               &               'parent grid ln_dynspg_exp :'//cl_check3  ,  &
+               &               'child  grid ln_dynspg_exp :'//cl_check4  ,  &
+               &               'those logicals should be identical' )                 
+         STOP
+      ENDIF
+
+      ! Check if identical linear free surface option
+      IF ( ( Agrif_Parent(ln_linssh ).AND.(.NOT.ln_linssh )).OR.&
+         & ( (.NOT.Agrif_Parent(ln_linssh)).AND.ln_linssh ) ) THEN
+         WRITE(cl_check1,*)  Agrif_Parent(ln_linssh )
+         WRITE(cl_check2,*)  ln_linssh
+         CALL ctl_stop( 'Incompatible linearized fs option between grids',  &
+               &               'parent grid ln_linssh  :'//cl_check1     ,  &
+               &               'child  grid ln_linssh  :'//cl_check2     ,  &
+               &               'those logicals should be identical' )                  
          STOP
       ENDIF
@@ -306,27 +316,39 @@
    ENDIF
    ! 
-   ! Do update at initialisation because not done before writing restarts
-   ! This would indeed change boundary conditions values at initial time
-   ! hence produce restartability issues.
-   ! Note that update below is recursive (with lk_agrif_doupd=T):
-   ! 
-! JC: I am not sure if Agrif_MaxLevel() is the "relative"
-!     or the absolute maximum nesting level...TBC                        
-   IF ( Agrif_Level().EQ.Agrif_MaxLevel() ) THEN 
-      ! NB: Do tracers first, dynamics after because nbcline incremented in dynamics
-      CALL Agrif_Update_tra()
-      CALL Agrif_Update_dyn()
-   ENDIF
-   !
+END SUBROUTINE Agrif_InitValues_cont
+
+RECURSIVE SUBROUTINE Agrif_Update_ini( )
+   !!----------------------------------------------------------------------
+   !!                 *** ROUTINE agrif_Update_ini ***
+   !!
+   !! ** Purpose :: Recursive update done at initialization
+   !!----------------------------------------------------------------------
+   USE dom_oce
+   USE agrif_opa_update
+#if defined key_top
+   USE agrif_top_update
+#endif
+   !
+   IMPLICIT NONE
+   !!----------------------------------------------------------------------
+   !
+   IF (Agrif_Root()) RETURN
+   !
+   IF (.NOT.ln_linssh) CALL Agrif_Update_vvl()
+   CALL Agrif_Update_tra()
+#if defined key_top
+   CALL Agrif_Update_Trc()
+#endif
+   CALL Agrif_Update_dyn()
 # if defined key_zdftke
-   CALL Agrif_Update_tke(0)
-# endif
-   !
-   Agrif_UseSpecialValueInUpdate = .FALSE.
-   nbcline = 0
-   lk_agrif_doupd = .FALSE.
-   !
-END SUBROUTINE Agrif_InitValues_cont
-
+! JC remove update because this precludes from perfect restartability
+!!   CALL Agrif_Update_tke()
+# endif
+
+   CALL Agrif_ChildGrid_To_ParentGrid()
+   CALL Agrif_Update_ini()
+   CALL Agrif_ParentGrid_To_ChildGrid()
+
+END SUBROUTINE agrif_update_ini
 
 SUBROUTINE agrif_declare_var
@@ -371,8 +393,8 @@
    CALL agrif_declare_variable((/2,2/),(/3,3/),(/'x','y'/),(/1,1/),(/nlci,nlcj/),sshn_id)
 
-# if defined key_zdftke
-   CALL agrif_declare_variable((/2,2,0/),(/3,3,0/),(/'x','y','N'/),(/1,1,1/),(/jpi,jpj,jpk/), en_id)
-   CALL agrif_declare_variable((/2,2,0/),(/3,3,0/),(/'x','y','N'/),(/1,1,1/),(/jpi,jpj,jpk/),avt_id)
-   CALL agrif_declare_variable((/2,2,0/),(/3,3,0/),(/'x','y','N'/),(/1,1,1/),(/jpi,jpj,jpk/),avm_id)
+# if defined key_zdftke || defined key_zdfgls
+   CALL agrif_declare_variable((/2,2,0/),(/3,3,0/),(/'x','y','N'/),(/1,1,1/),(/nlci,nlcj,jpk/), en_id)
+   CALL agrif_declare_variable((/2,2,0/),(/3,3,0/),(/'x','y','N'/),(/1,1,1/),(/nlci,nlcj,jpk/),avt_id)
+   CALL agrif_declare_variable((/2,2,0/),(/3,3,0/),(/'x','y','N'/),(/1,1,1/),(/nlci,nlcj,jpk/),avm_id)
 # endif
 
@@ -400,5 +422,5 @@
    CALL Agrif_Set_bcinterp(vmsk_id,interp=AGRIF_constant)
 
-# if defined key_zdftke
+# if defined key_zdftke || defined key_zdfgls
    CALL Agrif_Set_bcinterp(avm_id ,interp=AGRIF_linear)
 # endif
@@ -411,7 +433,4 @@
    CALL Agrif_Set_bc(vn_interp_id,(/0,1/))
 
-!   CALL Agrif_Set_bc(tsn_sponge_id,(/-3*Agrif_irhox(),0/))
-!   CALL Agrif_Set_bc(un_sponge_id,(/-2*Agrif_irhox()-1,0/))
-!   CALL Agrif_Set_bc(vn_sponge_id,(/-2*Agrif_irhox()-1,0/))
    CALL Agrif_Set_bc(tsn_sponge_id,(/-nn_sponge_len*Agrif_irhox()-1,0/))
    CALL Agrif_Set_bc(un_sponge_id ,(/-nn_sponge_len*Agrif_irhox()-1,0/))
@@ -428,21 +447,37 @@
    CALL Agrif_Set_bc(vmsk_id,(/0,0/))
 
+# if defined key_zdftke || defined key_zdfgls
+   CALL Agrif_Set_bc(avm_id ,(/0,1/))
+# endif
+
+   ! 4. Update type
+   !--------------- 
+   CALL Agrif_Set_Updatetype(scales_t_id, update = AGRIF_Update_Average)
+
+# if defined UPD_HIGH
+   CALL Agrif_Set_Updatetype(tsn_id, update = Agrif_Update_Full_Weighting)
+   CALL Agrif_Set_Updatetype(un_update_id,update1 = Agrif_Update_Average, update2 = Agrif_Update_Full_Weighting)
+   CALL Agrif_Set_Updatetype(vn_update_id,update1 = Agrif_Update_Full_Weighting, update2 = Agrif_Update_Average)
+
+   CALL Agrif_Set_Updatetype(ub2b_update_id,update1 = Agrif_Update_Average, update2 = Agrif_Update_Full_Weighting)
+   CALL Agrif_Set_Updatetype(vb2b_update_id,update1 = Agrif_Update_Full_Weighting, update2 = Agrif_Update_Average)
+   CALL Agrif_Set_Updatetype(sshn_id, update = Agrif_Update_Full_Weighting)
+   CALL Agrif_Set_Updatetype(e3t_id, update = Agrif_Update_Full_Weighting)
+
 # if defined key_zdftke
-   CALL Agrif_Set_bc(avm_id ,(/0,1/))
-# endif
-
-   ! 5. Update type
-   !--------------- 
+   CALL Agrif_Set_Updatetype( en_id, update = AGRIF_Update_Full_Weighting)
+   CALL Agrif_Set_Updatetype(avt_id, update = AGRIF_Update_Full_Weighting)
+   CALL Agrif_Set_Updatetype(avm_id, update = AGRIF_Update_Full_Weighting)
+# endif
+
+#else
    CALL Agrif_Set_Updatetype(tsn_id, update = AGRIF_Update_Average)
-
-   CALL Agrif_Set_Updatetype(scales_t_id, update = AGRIF_Update_Average)
-
    CALL Agrif_Set_Updatetype(un_update_id,update1 = Agrif_Update_Copy, update2 = Agrif_Update_Average)
    CALL Agrif_Set_Updatetype(vn_update_id,update1 = Agrif_Update_Average, update2 = Agrif_Update_Copy)
 
-   CALL Agrif_Set_Updatetype(sshn_id, update = AGRIF_Update_Average)
-
    CALL Agrif_Set_Updatetype(ub2b_update_id,update1 = Agrif_Update_Copy, update2 = Agrif_Update_Average)
    CALL Agrif_Set_Updatetype(vb2b_update_id,update1 = Agrif_Update_Average, update2 = Agrif_Update_Copy)
+   CALL Agrif_Set_Updatetype(sshn_id, update = AGRIF_Update_Average)
+   CALL Agrif_Set_Updatetype(e3t_id, update = AGRIF_Update_Average)
 
 # if defined key_zdftke
@@ -452,13 +487,5 @@
 # endif
 
-! High order updates
-!   CALL Agrif_Set_Updatetype(tsn_id, update = Agrif_Update_Full_Weighting)
-!   CALL Agrif_Set_Updatetype(un_update_id,update1 = Agrif_Update_Average, update2 = Agrif_Update_Full_Weighting)
-!   CALL Agrif_Set_Updatetype(vn_update_id,update1 = Agrif_Update_Full_Weighting, update2 = Agrif_Update_Average)
-!
-!   CALL Agrif_Set_Updatetype(ub2b_update_id,update1 = Agrif_Update_Average, update2 = Agrif_Update_Full_Weighting)
-!   CALL Agrif_Set_Updatetype(vb2b_update_id,update1 = Agrif_Update_Full_Weighting, update2 = Agrif_Update_Average)
-!   CALL Agrif_Set_Updatetype(sshn_id, update = Agrif_Update_Full_Weighting)
-
+#endif
    !
 END SUBROUTINE agrif_declare_var
@@ -733,21 +760,4 @@
       ENDIF
 
-      ! Check coordinates
-      IF( ln_zps ) THEN
-         ! check parameters for partial steps 
-         IF( Agrif_Parent(e3zps_min) .NE. e3zps_min ) THEN
-            WRITE(*,*) 'incompatible e3zps_min between grids'
-            WRITE(*,*) 'parent grid :',Agrif_Parent(e3zps_min)
-            WRITE(*,*) 'child grid  :',e3zps_min
-            WRITE(*,*) 'those values should be identical'
-            STOP
-         ENDIF
-         IF( Agrif_Parent(e3zps_rat) .NE. e3zps_rat ) THEN
-            WRITE(*,*) 'incompatible e3zps_rat between grids'
-            WRITE(*,*) 'parent grid :',Agrif_Parent(e3zps_rat)
-            WRITE(*,*) 'child grid  :',e3zps_rat
-            WRITE(*,*) 'those values should be identical'                  
-            STOP
-         ENDIF
       ENDIF
       ! Check passive tracer cell
@@ -756,9 +766,4 @@
       ENDIF
    ENDIF
-
-   CALL Agrif_Update_trc(0)
-   !
-   Agrif_UseSpecialValueInUpdate = .FALSE.
-   nbcline_trc = 0
    !
 END SUBROUTINE Agrif_InitValues_cont_top
@@ -792,14 +797,13 @@
    !-----------------------------
    CALL Agrif_Set_bc(trn_id,(/0,1/))
-!   CALL Agrif_Set_bc(trn_sponge_id,(/-3*Agrif_irhox(),0/))
    CALL Agrif_Set_bc(trn_sponge_id,(/-nn_sponge_len*Agrif_irhox()-1,0/))
 
-   ! 5. Update type
+   ! 4. Update type
    !--------------- 
+# if defined UPD_HIGH
+   CALL Agrif_Set_Updatetype(trn_id, update = Agrif_Update_Full_Weighting)
+#else
    CALL Agrif_Set_Updatetype(trn_id, update = AGRIF_Update_Average)
-
-!   Higher order update
-!   CALL Agrif_Set_Updatetype(tsn_id, update = Agrif_Update_Full_Weighting)
-
+#endif
    !
 END SUBROUTINE agrif_declare_var_top
@@ -866,4 +870,6 @@
    IF (lk_mpp) iminspon = MIN(iminspon,FLOOR(REAL(jpi-2)/REAL(Agrif_irhox())), FLOOR(REAL(jpj-2)/REAL(Agrif_irhox())) )
    IF (nn_sponge_len > iminspon)  CALL ctl_stop('agrif sponge length is too large')
+   ! Check update frequency
+   IF (MOD((nitend-nit000+1), nbclineupdate).NE.0 ) CALL ctl_stop('number of time steps should be a multiple of nn_cln_update')
    !
    IF( agrif_oce_alloc()  > 0 )   CALL ctl_warn('agrif agrif_oce_alloc: allocation of arrays failed')
@@ -878,5 +884,5 @@
 SUBROUTINE Agrif_InvLoc( indloc, nprocloc, i, indglob )
    !!----------------------------------------------------------------------
-   !!                     *** ROUTINE Agrif_detect ***
+   !!                     *** ROUTINE Agrif_InvLoc ***
    !!----------------------------------------------------------------------
    USE dom_oce
Index: /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90
===================================================================
--- /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90	(revision 8740)
+++ /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90	(revision 8741)
@@ -276,4 +276,12 @@
                ENDIF
             END DO
+#if defined key_agrif 
+	    IF( .NOT. AGRIF_Root() ) THEN 
+	       IF ((nbondi ==  1).OR.(nbondi == 2)) fmask(nlci-1 , :     ,jk) = 0.e0      ! east 
+	       IF ((nbondi == -1).OR.(nbondi == 2)) fmask(1      , :     ,jk) = 0.e0      ! west 
+ 	       IF ((nbondj ==  1).OR.(nbondj == 2)) fmask(:      ,nlcj-1 ,jk) = 0.e0      ! north 
+	       IF ((nbondj == -1).OR.(nbondj == 2)) fmask(:      ,1      ,jk) = 0.e0      ! south 
+	    ENDIF 
+#endif 
          END DO
          !
Index: /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90
===================================================================
--- /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 8740)
+++ /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 8741)
@@ -1029,5 +1029,5 @@
       !
 #if defined key_agrif
-      IF(.NOT.Agrif_Root() )   CALL ctl_stop( 'AGRIF not implemented with non-linear free surface' )
+      IF( (.NOT.Agrif_Root()).AND.(.NOT.ln_vvl_zstar) )CALL ctl_stop( 'AGRIF is implemented with zstar coordinate only' )
 #endif
       !
Index: /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90
===================================================================
--- /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 8740)
+++ /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 8741)
@@ -132,6 +132,6 @@
             ! so that asselin contribution is removed at the same time 
             DO jk = 1, jpkm1
-               un(:,:,jk) = ( un(:,:,jk) - un_adv(:,:) + un_b(:,:) )*umask(:,:,jk)
-               vn(:,:,jk) = ( vn(:,:,jk) - vn_adv(:,:) + vn_b(:,:) )*vmask(:,:,jk)
+               un(:,:,jk) = ( un(:,:,jk) - un_adv(:,:)*r1_hu_n(:,:) + un_b(:,:) )*umask(:,:,jk)
+               vn(:,:,jk) = ( vn(:,:,jk) - vn_adv(:,:)*r1_hv_n(:,:) + vn_b(:,:) )*vmask(:,:,jk)
             END DO  
          ENDIF
Index: /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 8740)
+++ /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 8741)
@@ -52,4 +52,5 @@
 #if defined key_agrif
    USE agrif_opa_interp ! agrif
+   USE agrif_oce
 #endif
 #if defined key_asminc   
@@ -76,5 +77,5 @@
 
    !! Time filtered arrays at baroclinic time step:
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   un_adv , vn_adv     !: Advection vel. at "now" barocl. step
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   un_adv , vn_adv     !: Advection fluxes at "now" barocl. step
 
    !! * Substitutions
@@ -127,5 +128,5 @@
       !!      -Update the filtered free surface at step "n+1"      : ssha
       !!      -Update filtered barotropic velocities at step "n+1" : ua_b, va_b
-      !!      -Compute barotropic advective velocities at step "n" : un_adv, vn_adv
+      !!      -Compute barotropic advective fluxes at step "n"     : un_adv, vn_adv
       !!      These are used to advect tracers and are compliant with discrete
       !!      continuity equation taken at the baroclinic time steps. This 
@@ -1019,15 +1020,12 @@
       !
       ! Set advection velocity correction:
-      zwx(:,:) = un_adv(:,:)
-      zwy(:,:) = vn_adv(:,:)
-      IF( ( kt == nit000 .AND. neuler==0 ) .OR. .NOT.ln_bt_fw ) THEN     
-         un_adv(:,:) = zwx(:,:) * r1_hu_n(:,:)
-         vn_adv(:,:) = zwy(:,:) * r1_hv_n(:,:)
-      ELSE
-         un_adv(:,:) = z1_2 * ( ub2_b(:,:) + zwx(:,:) ) * r1_hu_n(:,:)
-         vn_adv(:,:) = z1_2 * ( vb2_b(:,:) + zwy(:,:) ) * r1_hv_n(:,:)
-      END IF
-
-      IF( ln_bt_fw ) THEN ! Save integrated transport for next computation
+      IF (ln_bt_fw) THEN
+         zwx(:,:) = un_adv(:,:)
+         zwy(:,:) = vn_adv(:,:)
+         IF( .NOT.( kt == nit000 .AND. neuler==0 ) ) THEN
+            un_adv(:,:) = z1_2 * ( ub2_b(:,:) + zwx(:,:) ) 
+            vn_adv(:,:) = z1_2 * ( vb2_b(:,:) + zwy(:,:) )
+         END IF
+         ! Save integrated transport for next computation
          ub2_b(:,:) = zwx(:,:)
          vb2_b(:,:) = zwy(:,:)
@@ -1065,11 +1063,11 @@
       DO jk = 1, jpkm1
          ! Correct velocities:
-         un(:,:,jk) = ( un(:,:,jk) + un_adv(:,:) - un_b(:,:) ) * umask(:,:,jk)
-         vn(:,:,jk) = ( vn(:,:,jk) + vn_adv(:,:) - vn_b(:,:) ) * vmask(:,:,jk)
+         un(:,:,jk) = ( un(:,:,jk) + un_adv(:,:)*r1_hu_n(:,:) - un_b(:,:) ) * umask(:,:,jk)
+         vn(:,:,jk) = ( vn(:,:,jk) + vn_adv(:,:)*r1_hv_n(:,:) - vn_b(:,:) ) * vmask(:,:,jk)
          !
       END DO
       !
-      CALL iom_put(  "ubar", un_adv(:,:)      )    ! barotropic i-current
-      CALL iom_put(  "vbar", vn_adv(:,:)      )    ! barotropic i-current
+      CALL iom_put(  "ubar", un_adv(:,:)*r1_hu_n(:,:) )    ! barotropic i-current
+      CALL iom_put(  "vbar", vn_adv(:,:)*r1_hv_n(:,:) )    ! barotropic i-current
       !
 #if defined key_agrif
@@ -1297,5 +1295,5 @@
 #if defined key_agrif
       ! Restrict the use of Agrif to the forward case only
-      IF( .NOT.ln_bt_fw .AND. .NOT.Agrif_Root() )   CALL ctl_stop( 'AGRIF not implemented if ln_bt_fw=.FALSE.' )
+!!!      IF( .NOT.ln_bt_fw .AND. .NOT.Agrif_Root() )   CALL ctl_stop( 'AGRIF not implemented if ln_bt_fw=.FALSE.' )
 #endif
       !
